include \masm32\MasmBasic\MasmBasic.inc	; library: http://www.masm32.com/board/index.php?topic=12460

.code
start:	; normal CP is 1252 for Western text; user must set console properties to Lucida Console
	; unfortunately, none of these show any effect...!
	; invoke SetConsoleOutputCP, 1252		; Western codepage
	; invoke SetConsoleOutputCP, CP_UTF8	; CP_UTF8 aka 65001 doesn't work
	; invoke SetConsoleOutputCP, 1256		; arabic codepage doesn't work
	; invoke SetConsoleOutputCP, 866		; russian codepage doesn't work
	TheString = 100
	While TheString LE 123	; 100=Russian, 123=Arabic test string
	  Let esi=wRes$(TheString)	; get a Unicode string from the resource stringtable
	  Let edi=Res$(TheString)	; get an ANSI string from the resource stringtable
;	  pushad
;	  invoke MessageBoxW, 0, esi, wChr$("Unicode is great:"), MB_OK	; works fine, displays Arabic or Russian text
;	  popad
	  ConsoleColor cBlack, cWhite	; first test
	  mov edx, esp	; save the slot address
	  push edx	; create the slot
	  push 0	; reserved para
	  push edx	; slot address for the chars written variable
	  push wLen(esi)	; numbytes
	  push esi	; ptr to the wide string
	  invoke GetStdHandle, STD_OUTPUT_HANDLE	; get handle to console output
	  push eax
	  call WriteConsoleW	; invoke WriteConsoleW, eax, 7, edx, 0	; eax=ptr TheChar, edx=ptr TheCount
	  pop edx

	  ConsoleColor cBlack, cYellow	; second test
	  Print CrLf$, edi, CrLf$	; ANSI print fails with ?????????

	  shl wLen(esi), 1	; *2, len in bytes
	  invoke WideCharToMultiByte, CP_UTF8, 0, esi, eax, 0, 0, NULL, NULL
	  inc eax
	  shl eax, 1
	  push eax
	  Let ebx=New$(eax)
	  pop eax
	  invoke WideCharToMultiByte, CP_UTF8, 0, esi, eax, ebx, eax, NULL, NULL

	  ConsoleColor cBlack, cWhite		; third test
	  invoke SetConsoleOutputCP, CP_UTF8	; CP_UTF8 aka 65001 WORKS...!!
	  Print ebx, String$(3, CrLf$)
	  TheString = TheString + 23
	ENDM

	inkey "OK"
	Exit
 
end start
